﻿Imports System.Runtime.InteropServices

Module SUS

    ' Public Const SUSlv_DEVICE_INTERFACE As String = "{82EFB874-53F7-4595-9B80-5388380A1B3A}"
    Public Const APP_NAME As String = "RefApp7 for VB2015"
    Public Const MAX_PATH As Integer = 260


    Public dWinUSBHandle As IntPtr
    'Public hWinUSBGuid As New System.Guid(SUS_DEVICE_INTERFACE)

    Public dFoundHandle As IntPtr



    Public Const SUSlv_RANGE_8BIT As UInteger = &H1
    Public Const SUSlv_RANGE_16BIT As UInteger = &H2
    Public Const SUSlv_RANGE_32BIT As UInteger = &H4
    Public Const SUSlv_RANGE_64BIT As UInteger = &H8

    Public Const SUSlv_ADRS_MASK As UInteger = &H3F
    Public Const SUSlv_RANGE_MASK As UInteger = &HC0

    Public Const SUSlv_CONFIG_MODE_ALTERA As Boolean = 0
    Public Const SUSlv_CONFIG_MODE_XILINX As Boolean = 1

    Public Const SUSlv_BOARDINFO_FIRMID As UShort = &HC0
    Public Const SUSlv_BOARDINFO_CHIPVER As UShort = &H80
    Public Const SUSlv_BOARDINFO_PID As UShort = &H40
    Public Const SUSlv_BOARDINFO_SPEED As UShort = &H0
    Public Const SUSlv_FULL_SPEED As UShort = &H0
    Public Const SUSlv_HIGH_SPEED As UShort = &H1
    Public Const SUSlv_SUPER_SPEED As UShort = &H2


    Public Const PID8000 As String = "SX-USB4"
    Public Const PID8001 As String = "KX-Card7"
    Public Const PID8002 As String = "CX-card5"
    Public Const PID8003 As String = "AX-Card7"



    'Smart-USBPlus APIの定義

    '   --------------------------------------------------------------------------------
    '   USBﾃﾞﾊﾞｲｽのｵｰﾌﾟﾝ/ｸﾛｰｽﾞ関数
    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Usb_Open(ByRef dFoundHandle As IntPtr, ByRef dWinUSBHandle As IntPtr) As Boolean
    End Function


    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Usb_Close(ByVal dFoundHandle As UInt64, ByVal dWinUSBHandle As UInt64) As Boolean
    End Function

    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀ転送用関数
    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Reg_Read(ByVal dWinUSBHandle As UInt64, ByVal adrs As UInteger, ByVal size As UInteger, ByRef rd As Byte) As Boolean
    End Function

    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Reg_Write(ByVal dWinUSBHandle As UInt64, ByVal adrs As UInteger, ByVal size As UInteger, ByRef wd As Byte) As Boolean
    End Function

    '   --------------------------------------------------------------------------------
    '   ﾒﾓﾘ転送操作用関数
    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Data_Write(ByVal dWinUSBHandle As UInt64, ByVal FileSize As UInteger, ByVal pBuffer As IntPtr) As Boolean
    End Function

    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Data_Read(ByVal dWinUSBHandle As UInt64, ByVal FileSize As UInteger, ByVal pBuffer As IntPtr) As Boolean
    End Function

    '   --------------------------------------------------------------------------------
    '   各種ﾕｰﾃｨﾘﾃｨ関数
    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Get_BoardInfo(ByVal dWinUSBHandle As UInt64, ByVal ByvalSel As UInteger, ByRef ID As UIntPtr) As Boolean
    End Function

    <DllImport("SUSlv.dll", CharSet:=CharSet.Unicode)>
    Public Function SUSlv_Usb_Config(ByVal dWinUSBHandle As UInt64, ByVal PathName As String) As Boolean
    End Function

    <DllImport("SUSlv.dll", CharSet:=CharSet.Unicode)>
    Public Function SUSlv_Usb_Config_KXCARD7(ByVal dWinUSBHandle As UInt64, ByVal PathName As String, ByVal Encrypt As Boolean) As Boolean
    End Function

    <DllImport("SUSlv.dll", CharSet:=CharSet.Unicode)>
    Public Function SUSlv_Usb_Config_CXCARD5(ByVal dWinUSBHandle As UInt64, ByVal PathName As String) As Boolean
    End Function

    <DllImport("SUSlv.dll")>
    Public Function SUSlv_I2c_Read(ByVal dWinUSBHandle As UInt64, ByVal DevAdrs As UInteger, ByVal RegAdrs As UInteger, ByRef Rd As Byte) As Boolean
    End Function

    <DllImport("SUSlv.dll")>
    Public Function SUSlv_I2c_Write(ByVal dWinUSBHandle As UInt64, ByVal DevAdrs As UInteger, ByVal RegAdrs As UInteger, ByVal Wd As Byte) As Boolean
    End Function

    <DllImport("SUSlv.dll")>
    Public Function SUSlv_Get_FPGA_Temp(ByVal dWinUSBHandle As UInt64, ByVal Sel As UShort, ByRef Temp As UShort) As Boolean
    End Function



End Module
